import base64
import cv2
import datetime
import fnmatch
import numpy as np
import os
import subprocess
import time

from datetime import datetime
from fischertechnik.machine_learning.ImageClassifier import ImageClassifier
from lib.camera import *
from lib.controller import *
from lib.display import *
from os.path import exists


label = None
filename = None
duration = None
num = None
ts = None
pos = None
prob = None
frame = None
keytext = None
stat_str = None
ts_process0 = None
detector = None
ts_process1 = None
result = None
ts_process = None
key = None


def train(label):
    global filename, duration, num, ts, pos, prob, frame, keytext, stat_str, ts_process0, detector, ts_process1, result, ts_process, key
    duration = (time.time() * 1000)
    pos = ''
    frame = TXT_SLD_M_USB1_1_camera.read_frame()
    ts = timestamp()
    saveFileandPublish('/opt/ft/workspaces/machine-learning-user/training-data/{}_{}.png'.format(label, ts))
    duration = (time.time() * 1000) - duration
    print('processing time: {:.0f} ms'.format(duration))
    display.set_attr("txt_label_result.text", str('{}_{}.png'.format(label, ts)))
    return num


def detect():
    global label, filename, duration, num, ts, pos, prob, frame, keytext, stat_str, ts_process0, detector, ts_process1, result, ts_process, key
    duration = (time.time() * 1000)
    prob = 0
    keytext = 'No feature found'
    pos = ''
    display.set_attr("img_label.text", str('Processing'))
    frame = TXT_SLD_M_USB1_1_camera.read_frame()
    ts_process0 = (time.time() * 1000)
    detector = ImageClassifier('/opt/ft/workspaces/machine-learning-user/image-classifier/model.tflite', '/opt/ft/workspaces/machine-learning-user/image-classifier/labels.txt')
    ts_process1 = (time.time() * 1000)
    result = detector.process_image(frame)
    ts_process = (time.time() * 1000)
    print('processing time: {:.0f} ms {:.0f} ms'.format(ts_process1 - ts_process0, ts_process - ts_process1))
    print(result)
    if len(result) > 0:
        prob = result[0]['probability']
        pos = result[0]['position']
        key = result[0]['label']
        keytext = ''
        print('1: {} {} {} {} {}'.format(key, keytext, num, prob, pos, ''))
        if key == 'OK':
            num = 1
        elif key == 'NOK':
            num = 2
        else:
            num = -1
    else:
        pass
    duration = (time.time() * 1000) - duration
    saveFileandPublish('/opt/ft/workspaces/last-image.png')
    display.set_attr("txt_label_result.text", str('<h3>Result: {} {:.3f}</h3>'.format(key, prob)))
    return num


def timestamp():
    global label, filename, duration, num, ts, pos, prob, frame, keytext, stat_str, ts_process0, detector, ts_process1, result, ts_process, key
    ts = datetime.now().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3] + "Z"
    return ts


def saveFileandPublish(filename):
    global label, duration, num, ts, pos, prob, frame, keytext, stat_str, ts_process0, detector, ts_process1, result, ts_process, key
    if not (exists('/opt/ft/workspaces/machine-learning-user/training-data')):
        print('create dir training-data')
        os.makedirs('/opt/ft/workspaces/machine-learning-user/training-data', exist_ok=True)
        subprocess.Popen(['chmod', '777', '/opt/ft/workspaces/machine-learning-user/training-data/'])
    if not (exists('/opt/ft/workspaces/machine-learning-user/image-classifier/')):
        print('create dir image-classifier')
        os.makedirs('/opt/ft/workspaces/machine-learning-user/image-classifier/', exist_ok=True)
        subprocess.Popen(['chmod', '777', '/opt/ft/workspaces/machine-learning-user/image-classifier/'])
    if(pos != ""):
        image = cv2.rectangle(frame, (pos[0], pos[1]), (pos[2], pos[3]), (180,105,0), 2)
    print("write png file: ", filename)
    cv2.imwrite(filename, frame)
    subprocess.Popen(['chmod', '777', filename])

    with open(filename, "rb") as img_file:
        my_string = base64.b64encode(img_file.read())
    imgb64 = "data:image/jpeg;base64," + (my_string.decode('utf-8'))
    time.sleep(0.2)
    displaystr= "<img width='200' height='150' src='" +  imgb64  + "'>"
    display.set_attr("img_label.text", str(displaystr))
    update_stat()


def update_stat():
    global label, filename, duration, num, ts, pos, prob, frame, keytext, stat_str, ts_process0, detector, ts_process1, result, ts_process, key
    dir_path = r'/opt/ft/workspaces/machine-learning-user/training-data'

    count_ok = len(fnmatch.filter(os.listdir(dir_path), 'OK_*.png'))

    count_nok = len(fnmatch.filter(os.listdir(dir_path), 'NOK_*.png'))

    stat_str = "data OK: <b>" + str(count_ok) + "</b> NOK: <b>" + str(count_nok) + "</b>"

    print(stat_str)
    display.set_attr("txt_label_stat.text", str(stat_str))


